﻿using PerpetuumSoft.Instrumentation.Model;
using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace ChartMultipleDataSourcesSample
{

    public static class DataSourceProvider
    {
        public static DataTable getActual()
        {
            DataTable result = new DataTable("result");
            initTable(result);
            result.ReadXml(HttpContext.Current.Server.MapPath("~/App_Data/Data.xml"));

            return result;
        }

        public static void initTable(DataTable table)
        {

            table.Columns.Add("time", typeof(int));
            table.Columns.Add("customer_in", typeof(int));
            table.Columns.Add("customer_out", typeof(int));


        }

    }

        public class CustomContext :
            IDataContext
        {
            private DataSet _data;

            public IEnumerable DataSet1 { get { return _data.Tables["DataSet1"].Rows; } }
            public IEnumerable DataSet2 { get { return _data.Tables["DataSet2"].Rows; } }

            public CustomContext()
            {
                _data = new DataSet
                    () { DataSetName = "MainDataSource" };

                DataTable res = DataSourceProvider.getActual();

                _data.Tables.Add("DataSet1");
                _data.Tables.Add("DataSet2");

                DataSourceProvider.initTable(_data.Tables["DataSet1"]);
                DataSourceProvider.initTable(_data.Tables["DataSet2"]);

                foreach (DataRow row in res.Rows)
                {
                    if ((int)row["customer_in"] > 0) 
                    {
                        _data.Tables["DataSet1"].Rows.Add(row["time"], row["customer_in"], row["customer_out"]);
                    }
                    if ((int)row["customer_out"] > 0)
                    {
                        _data.Tables["DataSet2"].Rows.Add(row["time"], row["customer_in"], row["customer_out"]);
                    }
                }
            }

            #region IDataContext Members

            public object GetDataList(string name)
            {
                switch (name)
                {
                    case "DataSet1":
                        return DataSet1;
                    default:
                        return DataSet2;
                }
            }

            public string[] GetDataListNames()
            {
                return new string[] { "DataSet1", "DataSet2" };
            }

            #endregion
        }

    }

